using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_DictionaryValue
    /// </summary>
    public partial class T_Sys_DictionaryValue
    {
        public T_Sys_DictionaryValue()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_DictionaryValueId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_DictionaryValue");
            strSql.Append(" where F_DictionaryValueId=@F_DictionaryValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictionaryValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DictionaryValueId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_DictionaryValue model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_DictionaryValue(");
            strSql.Append("F_DictionaryFlag,F_ValueCode,F_Name,F_Sort,F_Describe,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_DictionaryFlag,@F_ValueCode,@F_Name,@F_Sort,@F_Describe,@F_State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ValueCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Name", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Describe", SqlDbType.VarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_DictionaryFlag;
            parameters[1].Value = model.F_ValueCode;
            parameters[2].Value = model.F_Name;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Describe;
            parameters[5].Value = model.F_State;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_DictionaryValue model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_DictionaryValue set ");
            strSql.Append("F_DictionaryFlag=@F_DictionaryFlag,");
            strSql.Append("F_ValueCode=@F_ValueCode,");
            strSql.Append("F_Name=@F_Name,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_Describe=@F_Describe,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_DictionaryValueId=@F_DictionaryValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictionaryFlag", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ValueCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Name", SqlDbType.VarChar,50),
                    new SqlParameter("@F_Sort", SqlDbType.Int,4),
                    new SqlParameter("@F_Describe", SqlDbType.VarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.VarChar,50),
                    new SqlParameter("@F_DictionaryValueId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DictionaryFlag;
            parameters[1].Value = model.F_ValueCode;
            parameters[2].Value = model.F_Name;
            parameters[3].Value = model.F_Sort;
            parameters[4].Value = model.F_Describe;
            parameters[5].Value = model.F_State;
            parameters[6].Value = model.F_DictionaryValueId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_DictionaryValueId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryValue ");
            strSql.Append(" where F_DictionaryValueId=@F_DictionaryValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictionaryValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DictionaryValueId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_DictionaryValueIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictionaryValue ");
            strSql.Append(" where F_DictionaryValueId in (" + F_DictionaryValueIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_DictionaryValue GetModel(int F_DictionaryValueId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_DictionaryValueId,F_DictionaryFlag,F_ValueCode,F_Name,F_Sort,F_Describe,F_State from T_Sys_DictionaryValue ");
            strSql.Append(" where F_DictionaryValueId=@F_DictionaryValueId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictionaryValueId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_DictionaryValueId;

            Model.T_Sys_DictionaryValue model = new Model.T_Sys_DictionaryValue();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_DictionaryValue DataRowToModel(DataRow row)
        {
            Model.T_Sys_DictionaryValue model = new Model.T_Sys_DictionaryValue();
            if (row != null)
            {
                if (row["F_DictionaryValueId"] != null && row["F_DictionaryValueId"].ToString() != "")
                {
                    model.F_DictionaryValueId = int.Parse(row["F_DictionaryValueId"].ToString());
                }
                if (row["F_DictionaryFlag"] != null)
                {
                    model.F_DictionaryFlag = row["F_DictionaryFlag"].ToString();
                }
                if (row["F_ValueCode"] != null)
                {
                    model.F_ValueCode = row["F_ValueCode"].ToString();
                }
                if (row["F_Name"] != null)
                {
                    model.F_Name = row["F_Name"].ToString();
                }
                if (row["F_Sort"] != null && row["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(row["F_Sort"].ToString());
                }
                if (row["F_Describe"] != null)
                {
                    model.F_Describe = row["F_Describe"].ToString();
                }
                if (row["F_State"] != null && row["F_State"] != DBNull.Value)
                {
                    model.F_State = Convert.ToBoolean(row["F_State"]);
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_DictionaryValueId,F_DictionaryFlag,F_ValueCode,F_Name,F_Sort,F_Describe,F_State ");
            strSql.Append(" FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_DictionaryValueId,F_DictionaryFlag,F_ValueCode,F_Name,F_Sort,F_Describe,F_State ");
            strSql.Append(" FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_DictionaryValue ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_DictionaryValueId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_DictionaryValue T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }


        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
